(* Tactics for the proof in the eventually example.
 *)

fun istrans pos =
    t_compose_l
	[apply_r pos,
	 exists_r NONE pos,
	 (t_compose
	     (and_r pos)
	     [transrel_r pos,
	      (t_compose2
		  (apply_r pos)
		  (true_r pos))
	      ])
	 ]
fun handle_spec pos =
    t_compose_l
	[unfold_r pos,
	 apply_r pos,
	 cases_r pos,
	 handle_eq_r pos
	 ]
val handle_spec_or_istrans_max =
    t_while(t_orelse
		(t_rhs handle_spec)
		(t_rhs istrans))

fun proof_step pos =
    t_compose_l
	[unfold_r pos,
	 apply_r pos,
	 or_r pos,
	 (t_compose2
	     (and_r (pos+1))
	     (t_compose_l
		  [handle_spec_or_istrans_max,
		   box_r pos,
		   (apply_to_end_l transrel_l)
		   ]))
	 ]

fun split_nat pos =
    t_compose_l
	[unfold_app_l pos,
	 apply_l pos,
	 t_compose
	     (or_l pos)
	     [eq_subst pos, 
	      (t_compose_l
		   [exists_l pos,
		    and_l pos,
		    eq_subst pos
		    ])
	      ]
	     ]
	
fun the_proof() =
    (
     (* Set up induction over X. *)
     by(add_type_info (pt "X"));
     by(approx_l 1            );
     by(split_nat 1);

     (* Handle base case. *)
     by(proof_step 1);
     by(proof_step 1);
     by(proof_step 1);
     by(proof_step 1);

     (* Handle induction part. *)
     by(proof_step 1);
     by(proof_step 1);
     by(proof_step 1);
     by(proof_step 1);
     by(proof_step 1);
     by(proof_step 1);
     by(proof_step 1);
     discharge1();
     ()
     )

(*
    let fun simp() =
		  by(t_while(t_orelse
				 (t_rhs handle_spec)
				 (t_rhs istrans)))
	fun work() =
	    (simp();
	     work()) 
	    handle _ => 
		   (postpone(); 
		    work())
    in
	to_goal 1;
	work()
    end
*)
(* Adapted from the routine in the ElPurse example.
fun do_the_proof() =
  let
    val s = UserIO.get_current_sequent()
    val f = Sequent.get_formula_rhs(s,1)
  in
    if is_goal(UserIO.get_node()) then
      if is_gfp_app_r 1 s then
	if copydischarge1() orelse discharge1() then
	  do_the_proof()
	else
	  (print "*** DISCHARGE FAILED ***; treating rhs\n";
	   (by(Rule.approx_r 1)) handle _ => ();
	   by treat_rhs;
	   do_the_proof())
      else if Mmc.is_sat f andalso Mmc.is_box(#2(Mmc.sat_parts f)) then
	(print "*** IS A BOX SATISFACTION ***; calling do_step\n";
	 by do_step;
	 do_the_proof())
      else (postpone(); do_the_proof())
    else ()
  end
*)
